## boxes 1.3

=== Makefile ===
#
# boxes - Command line filter to draw/remove ASCII boxes around text
# Copyright (C) 1999  Thomas Jensen and the boxes contributors
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License, version 2, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#____________________________________________________________________________
#============================================================================


# The following line (GLOBALCONF) is the only line you should need to edit!
GLOBALCONF = /usr/share/boxes
GIT_STATUS = ($(shell git rev-parse --short HEAD)$(shell if [ $$(git status -s -uall | wc -l) -ge 1 ] ; then echo ", dirty" ; fi))
BVERSION   = 1.3

ALL_FILES  = LICENSE README.md README.Win32.md boxes-config
DOC_FILES  = doc/boxes.1 doc/boxes.el
PKG_NAME   = boxes-$(BVERSION)

.PHONY: clean build win32 debug win32.debug infomsg replaceinfos test package win32.package package_common


build debug: infomsg replaceinfos
	$(MAKE) -C src BOXES_PLATFORM=unix $@

win32: infomsg replaceinfos
	$(MAKE) -C src BOXES_PLATFORM=win32 build

win32.debug: infomsg replaceinfos
	$(MAKE) -C src BOXES_PLATFORM=win32 debug


infomsg:
	@echo "| For compilation info please refer to the boxes compilation FAQ"
	@echo "| at https://boxes.thomasjensen.com/docs/faq.html#q5"

replaceinfos: src/boxes.h doc/boxes.1

src/boxes.h: src/boxes.h.in src/regexp/regexp.h Makefile
	sed -e 's/--BVERSION--/$(BVERSION) $(GIT_STATUS)/; s/--GLOBALCONF--/$(subst /,\/,$(GLOBALCONF))/' src/boxes.h.in > src/boxes.h

doc/boxes.1: doc/boxes.1.in Makefile
	sed -e 's/--BVERSION--/$(BVERSION)/; s/--GLOBALCONF--/$(subst /,\/,$(GLOBALCONF))/' doc/boxes.1.in > doc/boxes.1


$(PKG_NAME).tar.gz:
	mkdir -p $(PKG_NAME)/doc
	cp $(ALL_FILES) $(PKG_NAME)
	cp $(DOC_FILES) $(PKG_NAME)/doc
	$(MAKE) -C src PKG_NAME=$(PKG_NAME) BOXES_PLATFORM=$(BOXES_PLATFORM) flags_$(BOXES_PLATFORM) package
	if which gtar >/dev/null 2>&1 ; then gtar cfvz $(PKG_NAME).tar.gz $(PKG_NAME)/* ; \
	    else tar cfvz $(PKG_NAME).tar.gz $(PKG_NAME)/* ; fi
	rm -rf $(PKG_NAME)/

package: build
	$(MAKE) BOXES_PLATFORM=unix $(PKG_NAME).tar.gz

win32.package: win32
	$(MAKE) BOXES_PLATFORM=win32 $(PKG_NAME).tar.gz


clean:
	rm -f doc/boxes.1 src/boxes.h
	$(MAKE) -C src clean


test:
	cd test; ./testrunner.sh -suite


#EOF

=== src/Makefile ===
#
# boxes - Command line filter to draw/remove ASCII boxes around text
# Copyright (C) 1999  Thomas Jensen and the boxes contributors
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License, version 2, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#____________________________________________________________________________
#============================================================================


LEX        = flex
YACC       = bison
CC         = gcc

GEN_HDR    = parser.h boxes.h
GEN_SRC    = parser.c lex.yy.c
GEN_FILES  = $(GEN_SRC) $(GEN_HDR)
ORIG_HDRCL = boxes.h.in config.h
ORIG_HDR   = $(ORIG_HDRCL) lexer.h tools.h shape.h generate.h remove.h
ORIG_GEN   = lexer.l parser.y
ORIG_NORM  = boxes.c tools.c shape.c generate.c remove.c
ORIG_SRC   = $(ORIG_GEN) $(ORIG_NORM)
ORIG_FILES = $(ORIG_SRC) $(ORIG_HDR)
OTH_FILES  = Makefile

ALL_FILES  = $(ORIG_FILES) $(GEN_FILES) $(OTH_FILES)


.PHONY: clean build debug package flags_unix flags_win32 flags_


build: flags_$(BOXES_PLATFORM)
	$(MAKE) BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" CFLAGS_ADDTL="-O $(CFLAGS_ADDTL)" STRIP=true flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)

debug: flags_$(BOXES_PLATFORM)
	$(MAKE) BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" CFLAGS_ADDTL="-g $(CFLAGS_ADDTL)" STRIP=false flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)

boxes: $(ALL_OBJ)
	$(MAKE) -C regexp CC=$(CC) libregexp.a
	$(CC) $(LDFLAGS) $(ALL_OBJ) -o $(BOXES_EXECUTABLE_NAME) -lregexp
	if [ "$(STRIP)" = "true" ] ; then strip $(BOXES_EXECUTABLE_NAME) ; fi

boxes.exe: $(ALL_OBJ)
	$(CC) $(LDFLAGS) $(ALL_OBJ) -o $(BOXES_EXECUTABLE_NAME) -lkernel32
	if [ "$(STRIP)" = "true" ] ; then strip $(BOXES_EXECUTABLE_NAME) ; fi


flags_unix:
	$(eval CFLAGS := -I. -Iregexp -Wall -W $(CFLAGS_ADDTL))
	$(eval LDFLAGS := -Lregexp $(LDFLAGS_ADDTL))
	$(eval BOXES_EXECUTABLE_NAME := boxes)
	$(eval ALL_OBJ := $(GEN_SRC:.c=.o) $(ORIG_NORM:.c=.o))

flags_win32:
	$(eval CFLAGS := -Os -s -m32 -I. -Iregexp -Wall -W $(CFLAGS_ADDTL))
	$(eval LDFLAGS := -s -m32)
	$(eval BOXES_EXECUTABLE_NAME := boxes.exe)
	$(eval ALL_OBJ := $(GEN_SRC:.c=.o) $(ORIG_NORM:.c=.o) regexp/regexp.o regexp/regsub.o misc/getopt.o)

flags_:
	@echo Please call make from the top level directory.
	exit 1

parser.c parser.h: parser.y boxes.h regexp/regexp.h
	$(YACC) -o parser.c -d parser.y

lex.yy.c: lexer.l boxes.h
	$(LEX) -t lexer.l > lexer.tmp.c
	echo '#include "config.h"' > lex.yy.c
	cat lexer.tmp.c >> lex.yy.c
	rm lexer.tmp.c


boxes.o: boxes.c boxes.h regexp/regexp.h shape.h tools.h generate.h remove.h config.h
tools.o: tools.c tools.h boxes.h shape.h config.h
shape.o: shape.c shape.h boxes.h config.h tools.h
generate.o: generate.c generate.h boxes.h shape.h tools.h config.h
remove.o: remove.c remove.h boxes.h shape.h tools.h config.h
lex.yy.o: lex.yy.c parser.h tools.h shape.h lexer.h config.h
parser.o: parser.c parser.h tools.h shape.h lexer.h config.h
regexp/regexp.o: regexp/regexp.c
regexp/regsub.o: regexp/regsub.c
misc/getopt.o: misc/getopt.c


package: $(BOXES_EXECUTABLE_NAME)
	if [ -z "$(PKG_NAME)" ] ; then exit 1 ; fi
	cp $(BOXES_EXECUTABLE_NAME) ../$(PKG_NAME)

clean: flags_unix
	rm -f $(ALL_OBJ)
	rm -f $(GEN_FILES)
	rm -f core boxes boxes.exe
	$(MAKE) -C regexp clean


#EOF

=== src/regexp/Makefile ===
#
# boxes - Command line filter to draw/remove ASCII boxes around text
# Copyright (C) 1999  Thomas Jensen and the boxes contributors
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License, version 2, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#____________________________________________________________________________
#============================================================================


CFLAGS   = -O -I. $(CFLAGS_ADDTL)

ALL_CL   = regexp/regexp.c regexp/regsub.c
C_SRC    = $(notdir $(ALL_CL))
ALLFILES = Makefile $(C_SRC) regexp.h regmagic.h
ALLOBJ   = $(C_SRC:.c=.o)


.PHONY: clean build debug


build: libregexp.a
debug: libregexp.a

libregexp.a: $(ALLOBJ)
	ar cr libregexp.a $(ALLOBJ)

regexp.o: regexp.c regmagic.h regexp.h ../config.h
regsub.o: regsub.c regmagic.h regexp.h ../config.h

.c.o:
	$(CC) $(CFLAGS) -c $<


clean:
	rm -f $(ALLOBJ) libregexp.a core


#EOF

=== debian/changelog ===
boxes (1.3-1) unstable; urgency=medium

  * New upstream version 1.3
  * Update copyright years for debian/* packaging files
  * Refresh default-GLOBALCONF-for-Debian.patch
  * Refresh do-not-strip-boxes-binary-by-default.patch
  * Drop spelling-error-in-manpage.patch (applied upstream)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 27 Feb 2019 06:55:46 +0100

boxes (1.2-4) unstable; urgency=medium

  * Add an initial Gitlab CI config file
  * debian/.gitlab-ci.yml: Update image used for Gitlab CI
  * Update .gitlab-ci.yml based on Salsa CI Team's template
  * GitLab CI/Lintian: install dpkg-dev, that ships dpkg-architecture, needed
    to run some Lintian checks
  * Replace home-made GitLab CI with the standard Salsa pipeline
  * Bump Debhelper compat level to 12
  * Declare compliance with Debian policy 4.3.0
  * Inject additional CFLAGS from dpkg-buildflags into build.
    The project uses a custom approach to pass additional CFLAGS for the
    build via the CFLAGS_ADDTL variable.

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 28 Dec 2018 17:03:32 +0100

=== debian/control ===
Source: boxes
Section: text
Priority: optional
Maintainer: Salvatore Bonaccorso <carnil@debian.org>
Standards-Version: 4.3.0
Build-Depends: bison, debhelper-compat (= 12), flex
Vcs-Browser: https://salsa.debian.org/carnil/boxes
Vcs-Git: https://salsa.debian.org/carnil/boxes.git
Homepage: https://boxes.thomasjensen.com/
Rules-Requires-Root: no

Package: boxes
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: textmode box- and comment drawing filter
 Boxes is extremely configurable filter for adding and removing ASCII art
 (comments, for example) around chunks of text.  Most modern text editors
 support filtering text through external filters.  Boxes is such a filter.

=== debian/rules ===
#!/usr/bin/make -f

export CFLAGS_ADDTL+=$(shell dpkg-buildflags --get CFLAGS)

%:
	dh $@

=== debian/watch ===
version=3
https://boxes.thomasjensen.com/download boxes-(.*)\.src\.tar\.gz
https://github.com/ascii-boxes/boxes/releases /ascii-boxes/boxes/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip)$

## boxes 2.1.1

=== Makefile ===
#
# boxes - Command line filter to draw/remove ASCII boxes around text
# Copyright (c) 1999-2021 Thomas Jensen and the boxes contributors
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License, version 2, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#____________________________________________________________________________
#============================================================================


# The following line (GLOBALCONF) is the only line you should need to edit!
GLOBALCONF = /usr/share/boxes
GIT_STATUS = $(shell git describe --dirty --always 2>/dev/null || echo "n/a")
BVERSION   = 2.1.1

ALL_FILES  = LICENSE README.md boxes-config
DOC_FILES  = doc/boxes.1 doc/boxes.el
PKG_NAME   = boxes-$(BVERSION)
OUT_DIR    = out

WIN_PCRE2_VERSION      = 10.36
WIN_PCRE2_DIR          = pcre2-$(WIN_PCRE2_VERSION)
WIN_FLEX_BISON_VERSION = 2.5.24
WIN_FLEX_BISON_DIR     = flex_bison_$(WIN_FLEX_BISON_VERSION)

.PHONY: clean build win32 debug win32.debug win32.pcre infomsg replaceinfos test package win32.package package_common

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

build debug: infomsg replaceinfos
	$(MAKE) -C src BOXES_PLATFORM=unix LEX=flex YACC=bison $@

win32: infomsg replaceinfos
	$(MAKE) -C src BOXES_PLATFORM=win32 C_INCLUDE_PATH=../$(WIN_PCRE2_DIR)/src LDFLAGS=-L../$(WIN_PCRE2_DIR)/.libs \
	    LEX=../$(WIN_FLEX_BISON_DIR)/win_flex.exe YACC=../$(WIN_FLEX_BISON_DIR)/win_bison.exe build

win32.debug: infomsg replaceinfos
	$(MAKE) -C src BOXES_PLATFORM=win32 C_INCLUDE_PATH=../$(WIN_PCRE2_DIR)/src LDFLAGS=-L../$(WIN_PCRE2_DIR)/.libs \
	    LEX=../$(WIN_FLEX_BISON_DIR)/win_flex.exe YACC=../$(WIN_FLEX_BISON_DIR)/win_bison.exe debug

win32.prereq:
	# download components
	curl -LO https://ftp.pcre.org/pub/pcre/pcre2-$(WIN_PCRE2_VERSION).tar.gz
	curl -LO https://downloads.sourceforge.net/project/winflexbison/win_flex_bison-$(WIN_FLEX_BISON_VERSION).zip
	# unpack components
	tar xfz $(WIN_PCRE2_DIR).tar.gz
	unzip win_flex_bison-$(WIN_FLEX_BISON_VERSION).zip -d $(WIN_FLEX_BISON_DIR)
	# build the pcre2 dependency (only needed on Windows MinGW)
	cd $(WIN_PCRE2_DIR) ; \
	./configure --disable-pcre2-8 --disable-pcre2-16 --enable-pcre2-32 --disable-shared \
				--enable-never-backslash-C --enable-newline-is-anycrlf ; \
	$(MAKE)
	# remove downloaded archives
	rm pcre2-$(WIN_PCRE2_VERSION).tar.gz
	rm win_flex_bison-$(WIN_FLEX_BISON_VERSION).zip

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

infomsg:
	@echo "| For compilation info please refer to the boxes compilation FAQ"
	@echo "| at https://boxes.thomasjensen.com/faq.html#q5"

$(OUT_DIR):
	mkdir $(OUT_DIR)

replaceinfos: $(OUT_DIR)/boxes.h doc/boxes.1

$(OUT_DIR)/boxes.h: src/boxes.in.h Makefile | $(OUT_DIR)
	$(eval VERSION_STRING := $(shell if [ "${GIT_STATUS}" = "n/a" ]; then echo "${BVERSION}"; else echo "${BVERSION} (${GIT_STATUS})"; fi))
	sed -e 's/--BVERSION--/$(VERSION_STRING)/; s/--GLOBALCONF--/$(subst /,\/,$(GLOBALCONF))/' src/boxes.in.h > $(OUT_DIR)/boxes.h

doc/boxes.1: doc/boxes.1.in Makefile
	sed -e 's/--BVERSION--/$(BVERSION)/; s/--GLOBALCONF--/$(subst /,\/,$(GLOBALCONF))/' doc/boxes.1.in > doc/boxes.1

doc/boxes.1.html: doc/boxes.1
	cat doc/boxes.1 | groff -mandoc -Thtml > doc/boxes.1.raw.html
	sed -E -e 's/&lt;URL:([^&]+)&gt;/<a href="\1">\1<\/a>/g' < doc/boxes.1.raw.html > doc/boxes.1.html
	rm -f doc/boxes.1.raw.html
	@echo "Conversion complete. Excessive manual work remains."

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

$(OUT_DIR)/$(PKG_NAME).tar.gz:
	mkdir -p $(OUT_DIR)/$(PKG_NAME)/doc
	cp $(ALL_FILES) $(OUT_DIR)/$(PKG_NAME)/
	cp $(DOC_FILES) $(OUT_DIR)/$(PKG_NAME)/doc/
	$(MAKE) -C $(OUT_DIR) -f ../src/Makefile PKG_NAME=$(PKG_NAME) BOXES_PLATFORM=$(BOXES_PLATFORM) flags_$(BOXES_PLATFORM) package
	if which gtar >/dev/null 2>&1 ; then cd $(OUT_DIR) ; gtar cfvz $(PKG_NAME).tar.gz $(PKG_NAME)/* ; \
	    else cd $(OUT_DIR) ; tar cfvz $(PKG_NAME).tar.gz $(PKG_NAME)/* ; fi
	rm -rf $(OUT_DIR)/$(PKG_NAME)/

$(OUT_DIR)/zip/$(PKG_NAME).zip:
	mkdir -p $(OUT_DIR)/zip/$(PKG_NAME)
	unix2dos -n LICENSE $(OUT_DIR)/zip/$(PKG_NAME)/LICENSE.txt
	unix2dos -n boxes-config $(OUT_DIR)/zip/$(PKG_NAME)/boxes.cfg
	unix2dos -n README.md $(OUT_DIR)/zip/$(PKG_NAME)/README.md
	unix2dos -n README.Win32.md $(OUT_DIR)/zip/$(PKG_NAME)/README.Win32.md
	unix2dos -n doc/boxes.1 $(OUT_DIR)/zip/$(PKG_NAME)/boxes.1
	unix2dos -n doc/boxes.1.html $(OUT_DIR)/zip/$(PKG_NAME)/boxes-man-1.html
	cp -a $(OUT_DIR)/boxes.exe $(OUT_DIR)/zip/$(PKG_NAME)/
	cd $(OUT_DIR)/zip ; zip $(PKG_NAME).zip $(PKG_NAME)/*
	@echo Windows ZIP file created at $(OUT_DIR)/zip/$(PKG_NAME).zip

package: build
	$(MAKE) BOXES_PLATFORM=unix $(PKG_NAME).tar.gz

win32.package: win32 $(OUT_DIR)/zip/$(PKG_NAME).zip

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

choco: tools/LICENSE.txt tools/boxes.cfg tools/boxes.exe
	choco pack --version=$(BVERSION)

tools/LICENSE.txt: LICENSE
	unix2dos -n LICENSE tools/LICENSE.txt

tools/boxes.cfg: boxes-config
	unix2dos -n boxes-config tools/boxes.cfg

tools/boxes.exe: $(OUT_DIR)/boxes.exe
	cp $(OUT_DIR)/boxes.exe tools/

$(OUT_DIR)/boxes.exe: win32

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

clean:
	rm -f $(OUT_DIR)/boxes.h tools/boxes.cfg tools/LICENSE.txt tools/boxes.exe tools/README*.md boxes.portable.*.nupkg
	rm -f doc/boxes.1 doc/boxes.1.raw.html doc/boxes.1.html
	$(MAKE) -C src clean

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

test:
	cd test; ./testrunner.sh -suite


#EOF

=== src/Makefile ===
#
# boxes - Command line filter to draw/remove ASCII boxes around text
# Copyright (c) 1999-2021 Thomas Jensen and the boxes contributors
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License, version 2, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#____________________________________________________________________________
#============================================================================


CC         = gcc

OUT_DIR    = ../out
SRC_DIR    = ../src
VPATH      = $(SRC_DIR):$(SRC_DIR)/misc

GEN_HDR    = parser.h boxes.h lex.yy.h
GEN_SRC    = parser.c lex.yy.c
GEN_FILES  = $(GEN_SRC) $(GEN_HDR)
ORIG_HDRCL = boxes.in.h config.h
ORIG_HDR   = $(ORIG_HDRCL) cmdline.h discovery.h generate.h input.h list.h parsecode.h parsing.h query.h regulex.h \
             remove.h shape.h tools.h unicode.h
ORIG_GEN   = lexer.l parser.y
ORIG_NORM  = boxes.c cmdline.c discovery.c generate.c input.c list.c parsecode.c parsing.c query.c regulex.c remove.c \
             shape.c tools.c unicode.c
ORIG_SRC   = $(ORIG_GEN) $(ORIG_NORM)
ORIG_FILES = $(ORIG_SRC) $(ORIG_HDR)


.PHONY: check_dir clean build debug package flags_unix flags_win32 flags_

.NOTPARALLEL:

check_dir:
	@if [ "$(shell pwd | sed -e 's/^.*\///')" != "out" ] ; then \
	    echo ERROR: Please call make from the top level directory. ; \
		exit 1 ; \
	fi

$(OUT_DIR):
	mkdir $(OUT_DIR)

build: flags_$(BOXES_PLATFORM) | $(OUT_DIR)
	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" \
	    CFLAGS_ADDTL="-O $(CFLAGS_ADDTL)" STRIP=true flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)

debug: flags_$(BOXES_PLATFORM) | $(OUT_DIR)
	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" \
	    CFLAGS_ADDTL="-g $(CFLAGS_ADDTL)" STRIP=false flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)

boxes: $(ALL_OBJ) | check_dir
	$(CC) $(LDFLAGS) $^ -o $@ -lunistring -lpcre2-32
	if [ "$(STRIP)" = "true" ] ; then strip $@ ; fi

boxes.exe: $(ALL_OBJ) | check_dir
	$(CC) $(LDFLAGS) $^ -o $@ -lkernel32 -l:libunistring.a -l:libpcre2-32.a -l:libiconv.a
	if [ "$(STRIP)" = "true" ] ; then strip $@ ; fi


flags_unix:
	$(eval CFLAGS := -I. -I$(SRC_DIR) -Wall -W $(CFLAGS_ADDTL))
	$(eval LDFLAGS := $(LDFLAGS_ADDTL))
	$(eval BOXES_EXECUTABLE_NAME := boxes)
	$(eval ALL_OBJ := $(GEN_SRC:.c=.o) $(ORIG_NORM:.c=.o))

flags_win32:
	$(eval CFLAGS := -Os -s -m32 -I. -I$(SRC_DIR) -Wall -W $(CFLAGS_ADDTL))
	$(eval LDFLAGS := -s -m32)
	$(eval BOXES_EXECUTABLE_NAME := boxes.exe)
	$(eval ALL_OBJ := $(GEN_SRC:.c=.o) $(ORIG_NORM:.c=.o) getopt.o)

flags_:
	@echo Please call make from the top level directory.
	exit 1

parser.c parser.h: parser.y lex.yy.h | check_dir
	$(YACC) --warnings=all --verbose --defines=parser.h --output=parser.c $<

lex.yy.c lex.yy.h: lexer.l | check_dir
	$(LEX) --header-file=lex.yy.h $<

boxes.o:     boxes.c boxes.h cmdline.h discovery.h generate.h input.h list.h remove.h tools.h unicode.h config.h | check_dir
cmdline.o:   cmdline.c cmdline.h boxes.h tools.h config.h | check_dir
discovery.o: discovery.c discovery.h boxes.h tools.h config.h | check_dir
generate.o:  generate.c generate.h boxes.h shape.h tools.h unicode.h config.h | check_dir
getopt.o:    misc/getopt.c misc/getopt.h | check_dir
input.o:     input.c boxes.h input.h regulex.h tools.h unicode.h config.h | check_dir
lex.yy.o:    lex.yy.c parser.h boxes.h parsing.h tools.h shape.h config.h | check_dir
list.o:      list.c list.h boxes.h parsing.h query.h tools.h config.h | check_dir
parsecode.o: parsecode.c parser.h boxes.h tools.h lex.yy.h query.h regulex.h unicode.h config.h | check_dir
parser.o:    parser.c boxes.h lex.yy.h parser.h parsing.h tools.h shape.h discovery.h config.h | check_dir
parsing.o:   parsing.c parsing.h parser.h lex.yy.h boxes.h tools.h config.h | check_dir
query.o:     query.c query.h boxes.h list.h tools.h config.h | check_dir
regulex.o:   regulex.c regulex.h boxes.h tools.h unicode.h config.h | check_dir
remove.o:    remove.c remove.h boxes.h shape.h tools.h unicode.h config.h | check_dir
shape.o:     shape.c shape.h boxes.h tools.h config.h | check_dir
tools.o:     tools.c tools.h boxes.h shape.h unicode.h config.h | check_dir
unicode.o:   unicode.c unicode.h boxes.h tools.h config.h | check_dir

package: $(BOXES_EXECUTABLE_NAME)
	if [ -z "$(PKG_NAME)" ] ; then exit 1 ; fi
	cp -a $(BOXES_EXECUTABLE_NAME) $(PKG_NAME)/

clean:
	rm -rf $(OUT_DIR)
	rm -f core $(GEN_HDR)


#EOF

=== debian/changelog ===
boxes (2.1.1-2) unstable; urgency=medium

  * debian/copyright: Clarify upstream copyright stanza.
    - Update copyright information according to current upstream files.
    - Refer to GPL-2 only for the upstream files.
  * Fix quoting of closing comment tags in config

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 12 Dec 2021 13:30:21 +0100

boxes (2.1.1-1) unstable; urgency=medium

  * New upstream version 2.1.1
  * Update copyright years for upstream files
  * Add Build-Depends on libunistring-dev
  * Add Build-Depends on libpcre2-dev
  * Refresh "Change default config path for Debian"
  * Drop "Don't strip boxes binary already in Makefile"
  * Add Build-Depends on xxd used in upstream testsuite
  * debian/control: Wrap and sort fields
  * d/tests/control: smoke-test: Add xxd to Depends
  * d/tests/control: smoke-test: Adapt replacement in testrunner script to use
    installed boxes binary
  * dh_install: Install boxes binary from the new temporary build directory
  * d/tests/smoke-test: Copy installed boxes-config to run the tests
  * debian/copyright: Drop superfluous file pattern stanza (files dropped
    upstream)
  * debian/upstream/metadata: Remove obsolete field Homepage

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 12 Dec 2021 09:12:08 +0100

boxes (1.3-2) unstable; urgency=medium

  [ Salsa Pipeline ]
  * Update salsa CI pipeline

  [ Jenkins ]
  * Update watch file format version to 4.
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update pattern for GitHub archive URLs from /<org>/<repo>/tags
    page/<org>/<repo>/archive/<tag> -> /<org>/<repo>/archive/refs/tags/<tag>.
  * Remove obsolete field Name from debian/upstream/metadata (already present
    in machine-readable debian/copyright).
  * Update standards version to 4.5.1, no changes needed.
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.

  [ Salvatore Bonaccorso ]
  * Declare compliance with Debian policy 4.6.0
  * Update copyright years for debian/* packaging files
  * Rename Salsa CI configuration file to debian/salsa-ci.yml

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 11 Dec 2021 15:30:37 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,14 @@
 Section: text
 Priority: optional
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
-Standards-Version: 4.3.0
-Build-Depends: bison, debhelper-compat (= 12), flex
+Standards-Version: 4.6.0
+Build-Depends:
+ bison,
+ debhelper-compat (= 13),
+ flex,
+ libpcre2-dev,
+ libunistring-dev,
+ xxd <!nocheck>
 Vcs-Browser: https://salsa.debian.org/carnil/boxes
 Vcs-Git: https://salsa.debian.org/carnil/boxes.git
 Homepage: https://boxes.thomasjensen.com/

=== debian/tests/control ===
Tests: smoke-test
Depends: @, xxd

=== debian/watch ===
version=4
https://boxes.thomasjensen.com/download boxes-(.*)\.src\.tar\.gz
https://github.com/ascii-boxes/boxes/releases /ascii-boxes/boxes/archive/refs/tags/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip)$

## boxes 2.2.0

=== Makefile ===
--- 
+++ 
@@ -2,42 +2,43 @@
 # boxes - Command line filter to draw/remove ASCII boxes around text
 # Copyright (c) 1999-2021 Thomas Jensen and the boxes contributors
 #
-# This program is free software; you can redistribute it and/or modify it
-# under the terms of the GNU General Public License, version 2, as published
-# by the Free Software Foundation.
-#
-# This program is distributed in the hope that it will be useful, but
-# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
-# for more details.
-#
-# You should have received a copy of the GNU General Public License along
-# with this program; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-#____________________________________________________________________________
-#============================================================================
+# This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public
+# License, version 3, as published by the Free Software Foundation.
+# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
+# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+# You should have received a copy of the GNU General Public License along with this program.
+# If not, see <https://www.gnu.org/licenses/>.
+#____________________________________________________________________________________________________________________
+#====================================================================================================================
 
 
 # The following line (GLOBALCONF) is the only line you should need to edit!
 GLOBALCONF = /usr/share/boxes
 GIT_STATUS = $(shell git describe --dirty --always 2>/dev/null || echo "n/a")
-BVERSION   = 2.1.1
+BVERSION   = 2.2.0
 
 ALL_FILES  = LICENSE README.md boxes-config
 DOC_FILES  = doc/boxes.1 doc/boxes.el
 PKG_NAME   = boxes-$(BVERSION)
 OUT_DIR    = out
 
-WIN_PCRE2_VERSION      = 10.36
-WIN_PCRE2_DIR          = pcre2-$(WIN_PCRE2_VERSION)
+WIN_PCRE2_VERSION      = 10.40
+WIN_PCRE2_DIR          = vendor/pcre2-$(WIN_PCRE2_VERSION)
 WIN_FLEX_BISON_VERSION = 2.5.24
-WIN_FLEX_BISON_DIR     = flex_bison_$(WIN_FLEX_BISON_VERSION)
+WIN_FLEX_BISON_DIR     = vendor/flex_bison_$(WIN_FLEX_BISON_VERSION)
+WIN_CMOCKA_VERSION     = 1.1.0
+WIN_CMOCKA_DIR         = vendor/cmocka-$(WIN_CMOCKA_VERSION)
 
-.PHONY: clean build win32 debug win32.debug win32.pcre infomsg replaceinfos test package win32.package package_common
+.PHONY: clean build cov win32 debug win32.debug win32.pcre infomsg replaceinfos test covtest \
+        package win32.package package_common utest win32.utest
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
-build debug: infomsg replaceinfos
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+#    Build
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+build cov debug: infomsg replaceinfos
 	$(MAKE) -C src BOXES_PLATFORM=unix LEX=flex YACC=bison $@
 
 win32: infomsg replaceinfos
@@ -50,11 +51,14 @@
 
 win32.prereq:
 	# download components
-	curl -LO https://ftp.pcre.org/pub/pcre/pcre2-$(WIN_PCRE2_VERSION).tar.gz
+	curl -LO https://github.com/PCRE2Project/pcre2/releases/download/pcre2-$(WIN_PCRE2_VERSION)/pcre2-$(WIN_PCRE2_VERSION).tar.gz
 	curl -LO https://downloads.sourceforge.net/project/winflexbison/win_flex_bison-$(WIN_FLEX_BISON_VERSION).zip
+	curl -LO https://cmocka.org/files/$(WIN_CMOCKA_VERSION:%.0=%)/cmocka-$(WIN_CMOCKA_VERSION)-mingw.zip
 	# unpack components
-	tar xfz $(WIN_PCRE2_DIR).tar.gz
+	mkdir -p vendor
 	unzip win_flex_bison-$(WIN_FLEX_BISON_VERSION).zip -d $(WIN_FLEX_BISON_DIR)
+	tar -C vendor -xzf pcre2-$(WIN_PCRE2_VERSION).tar.gz
+	unzip cmocka-$(WIN_CMOCKA_VERSION)-mingw.zip -d vendor
 	# build the pcre2 dependency (only needed on Windows MinGW)
 	cd $(WIN_PCRE2_DIR) ; \
 	./configure --disable-pcre2-8 --disable-pcre2-16 --enable-pcre2-32 --disable-shared \
@@ -63,8 +67,9 @@
 	# remove downloaded archives
 	rm pcre2-$(WIN_PCRE2_VERSION).tar.gz
 	rm win_flex_bison-$(WIN_FLEX_BISON_VERSION).zip
+	rm cmocka-$(WIN_CMOCKA_VERSION)-mingw.zip
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
 infomsg:
 	@echo "| For compilation info please refer to the boxes compilation FAQ"
@@ -88,7 +93,10 @@
 	rm -f doc/boxes.1.raw.html
 	@echo "Conversion complete. Excessive manual work remains."
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+#    Standalone Packaging (Unix / Windows)
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
 $(OUT_DIR)/$(PKG_NAME).tar.gz:
 	mkdir -p $(OUT_DIR)/$(PKG_NAME)/doc
@@ -116,7 +124,10 @@
 
 win32.package: win32 $(OUT_DIR)/zip/$(PKG_NAME).zip
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+#    Chocolatey Packaging (Windows)
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
 choco: tools/LICENSE.txt tools/boxes.cfg tools/boxes.exe
 	choco pack --version=$(BVERSION)
@@ -132,17 +143,33 @@
 
 $(OUT_DIR)/boxes.exe: win32
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+#    Test
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+test:
+	cd test; ./testrunner.sh --suite
+
+covtest:
+	cd test; ./testrunner.sh --suite --coverage
+
+utest:
+	$(MAKE) -C utest BOXES_PLATFORM=unix utest
+
+win32.utest: $(OUT_DIR)
+	cp $(WIN_CMOCKA_DIR)/bin/cmocka.dll $(OUT_DIR)/
+	$(MAKE) -C utest BOXES_PLATFORM=win32 C_INCLUDE_PATH=../$(WIN_PCRE2_DIR)/src:../$(WIN_CMOCKA_DIR)/include \
+	    LDFLAGS_ADDTL="-L../$(WIN_PCRE2_DIR)/.libs -L../$(WIN_CMOCKA_DIR)/lib" utest
+
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+#    Cleanup
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
 clean:
 	rm -f $(OUT_DIR)/boxes.h tools/boxes.cfg tools/LICENSE.txt tools/boxes.exe tools/README*.md boxes.portable.*.nupkg
 	rm -f doc/boxes.1 doc/boxes.1.raw.html doc/boxes.1.html
 	$(MAKE) -C src clean
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
-
-test:
-	cd test; ./testrunner.sh -suite
-
 
 #EOF

=== src/Makefile ===
--- 
+++ 
@@ -2,20 +2,15 @@
 # boxes - Command line filter to draw/remove ASCII boxes around text
 # Copyright (c) 1999-2021 Thomas Jensen and the boxes contributors
 #
-# This program is free software; you can redistribute it and/or modify it
-# under the terms of the GNU General Public License, version 2, as published
-# by the Free Software Foundation.
-#
-# This program is distributed in the hope that it will be useful, but
-# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
-# for more details.
-#
-# You should have received a copy of the GNU General Public License along
-# with this program; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-#____________________________________________________________________________
-#============================================================================
+# This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public
+# License, version 3, as published by the Free Software Foundation.
+# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
+# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+# You should have received a copy of the GNU General Public License along with this program.
+# If not, see <https://www.gnu.org/licenses/>.
+#____________________________________________________________________________________________________________________
+#====================================================================================================================
 
 
 CC         = gcc
@@ -37,26 +32,32 @@
 ORIG_FILES = $(ORIG_SRC) $(ORIG_HDR)
 
 
-.PHONY: check_dir clean build debug package flags_unix flags_win32 flags_
+.PHONY: check_dir clean build cov debug package flags_unix flags_win32 flags_
 
 .NOTPARALLEL:
 
 check_dir:
 	@if [ "$(shell pwd | sed -e 's/^.*\///')" != "out" ] ; then \
 	    echo ERROR: Please call make from the top level directory. ; \
-		exit 1 ; \
+	    exit 1 ; \
 	fi
 
 $(OUT_DIR):
 	mkdir $(OUT_DIR)
 
 build: flags_$(BOXES_PLATFORM) | $(OUT_DIR)
-	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" \
-	    CFLAGS_ADDTL="-O $(CFLAGS_ADDTL)" STRIP=true flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)
+	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" STRIP=true \
+	    CFLAGS_ADDTL="-O $(CFLAGS_ADDTL)" flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)
+
+cov: flags_$(BOXES_PLATFORM) | $(OUT_DIR)
+	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" STRIP=false \
+	    CFLAGS_ADDTL="-g --coverage $(CFLAGS_ADDTL)" \
+	    LDFLAGS_ADDTL="--coverage $(LDFLAGS_ADDTL)" \
+	    flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)
 
 debug: flags_$(BOXES_PLATFORM) | $(OUT_DIR)
-	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" \
-	    CFLAGS_ADDTL="-g $(CFLAGS_ADDTL)" STRIP=false flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)
+	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" STRIP=false \
+	    CFLAGS_ADDTL="-g $(CFLAGS_ADDTL)" flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)
 
 boxes: $(ALL_OBJ) | check_dir
 	$(CC) $(LDFLAGS) $^ -o $@ -lunistring -lpcre2-32
@@ -69,15 +70,17 @@
 
 flags_unix:
 	$(eval CFLAGS := -I. -I$(SRC_DIR) -Wall -W $(CFLAGS_ADDTL))
-	$(eval LDFLAGS := $(LDFLAGS_ADDTL))
+	$(eval LDFLAGS := $(LDFLAGS) $(LDFLAGS_ADDTL))
 	$(eval BOXES_EXECUTABLE_NAME := boxes)
 	$(eval ALL_OBJ := $(GEN_SRC:.c=.o) $(ORIG_NORM:.c=.o))
+	echo $(filter-out boxes.o,$(ALL_OBJ)) > $(OUT_DIR)/modules.txt
 
 flags_win32:
 	$(eval CFLAGS := -Os -s -m32 -I. -I$(SRC_DIR) -Wall -W $(CFLAGS_ADDTL))
-	$(eval LDFLAGS := -s -m32)
+	$(eval LDFLAGS := $(LDFLAGS) -s -m32)
 	$(eval BOXES_EXECUTABLE_NAME := boxes.exe)
 	$(eval ALL_OBJ := $(GEN_SRC:.c=.o) $(ORIG_NORM:.c=.o) getopt.o)
+	echo $(filter-out boxes.o,$(ALL_OBJ)) > $(OUT_DIR)/modules.txt
 
 flags_:
 	@echo Please call make from the top level directory.
@@ -107,9 +110,11 @@
 tools.o:     tools.c tools.h boxes.h shape.h unicode.h config.h | check_dir
 unicode.o:   unicode.c unicode.h boxes.h tools.h config.h | check_dir
 
+
 package: $(BOXES_EXECUTABLE_NAME)
 	if [ -z "$(PKG_NAME)" ] ; then exit 1 ; fi
 	cp -a $(BOXES_EXECUTABLE_NAME) $(PKG_NAME)/
+
 
 clean:
 	rm -rf $(OUT_DIR)

=== utest/Makefile ===
#
# boxes - Command line filter to draw/remove ASCII boxes around text
# Copyright (c) 1999-2021 Thomas Jensen and the boxes contributors
#
# This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public
# License, version 3, as published by the Free Software Foundation.
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with this program.
# If not, see <https://www.gnu.org/licenses/>.
#____________________________________________________________________________________________________________________
#====================================================================================================================

CC         = gcc

OUT_DIR    = ../out
SRC_DIR    = ../src
UTEST_DIR  = ../utest
VPATH      = $(SRC_DIR):$(SRC_DIR)/misc:$(UTEST_DIR)

UTEST_NORM = global_mock.c cmdline_test.c tools_test.c regulex_test.o main.o
MOCKS = bx_fprintf

.PHONY: check_dir flags_unix flags_win32 flags_ utest

.NOTPARALLEL:

check_dir:
	@if [ "$(shell pwd | sed -e 's/^.*\///')" != "out" ] ; then \
	    echo ERROR: Please call make from the top level directory. ; \
	    exit 1 ; \
	fi

$(OUT_DIR):
	mkdir $(OUT_DIR)

flags_unix:
	$(eval CFLAGS := -I. -I$(SRC_DIR) -O -Wall -W $(CFLAGS_ADDTL))
	$(eval LDFLAGS := $(LDFLAGS) $(foreach MOCK,$(MOCKS),-Wl,--wrap=$(MOCK)) --coverage $(LDFLAGS_ADDTL))
	$(eval UTEST_EXECUTABLE_NAME := unittest)
	$(eval UTEST_OBJ := $(UTEST_NORM:.c=.o))

flags_win32:
	$(eval CFLAGS := -Os -s -std=c99 -m32 -I. -I$(SRC_DIR) -Wall -W $(CFLAGS_ADDTL))
	$(eval LDFLAGS := $(LDFLAGS) -s -std=c99 -m32 $(foreach MOCK,$(MOCKS),-Wl,--wrap=$(MOCK)) $(LDFLAGS_ADDTL))
	$(eval UTEST_EXECUTABLE_NAME := unittest.exe)
	$(eval UTEST_OBJ := $(UTEST_NORM:.c=.o))

flags_:
	@echo Please call make from the top level directory.
	exit 1

utest: flags_$(BOXES_PLATFORM) | $(OUT_DIR)
	$(MAKE) -C $(OUT_DIR) -f $(UTEST_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) UTEST_OBJ="$(UTEST_OBJ)" \
	    CFLAGS_ADDTL="$(CFLAGS_ADDTL)" flags_$(BOXES_PLATFORM) $(UTEST_EXECUTABLE_NAME)
	rm -f $(OUT_DIR)/*.gcda
	cd $(OUT_DIR) ; ./$(UTEST_EXECUTABLE_NAME)
	@OUT_DIR=$(OUT_DIR) SRC_DIR=$(SRC_DIR) ./report.sh

unittest: $(UTEST_OBJ) | check_dir
	$(CC) $(LDFLAGS) $^ $(shell cat modules.txt) -o $@ -lunistring -lpcre2-32 -lcmocka

unittest.exe: $(UTEST_OBJ) | check_dir
	$(CC) $(LDFLAGS) $^ $(shell cat modules.txt) -o $@ \
	    -lkernel32 -l:libunistring.a -l:libpcre2-32.a -l:libiconv.a -l:libcmocka.dll.a


global_mock.o:  global_mock.c global_mock.h boxes.h unicode.h config.h | check_dir
cmdline_test.o: cmdline_test.c cmdline_test.h global_mock.h boxes.h cmdline.h config.h | check_dir
tools_test.o:   tools_test.c tools_test.h tools.h config.h | check_dir
regulex_test.o: regulex_test.c regulex_test.h global_mock.h regulex.h config.h | check_dir
main.o:         main.c global_mock.h tools_test.h regulex_test.h config.h | check_dir

=== debian/changelog ===
boxes (2.2.0-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Defer stripping to dh_strip. (Closes: #1023275)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 01 Nov 2022 21:52:00 +0100

boxes (2.2.0-1) unstable; urgency=medium

  * debian/watch: Switch to watch tagged versions on github releases page
  * New upstream version 2.2.0
  * debian/copyright: Clarify upstream's license is GPL-3 only
  * Refresh "Change default config path for Debian" patch
  * Drop "Fix quoting of closing comment tags in config" (applied upstream)
  * Declare compliance with Debian policy 4.6.1
  * Update copyright years for debian/* packaging files
  * d/t/smoke-test: Adjust replacement to reference installed boxes binary
  * d/t/smoke-test: Create fake empty output directory in temporary
    autopkgtest directory
  * d/t/smoke-test: Correct argument to testrunner script
  * d/t/smoke-test: Really fix the replacement to use installed binary

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 23 Sep 2022 12:06:21 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: text
 Priority: optional
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Build-Depends:
  bison,
  debhelper-compat (= 13),

=== debian/rules ===
#!/usr/bin/make -f

export CFLAGS_ADDTL+=-O $(shell dpkg-buildflags --get CFLAGS)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- debug
